<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE concept PUBLIC "-//OASIS//DTD DITA Concept//EN" "concept.dtd">
<concept id="dg-oxy-label-function">
  <title>Label: oxy_label() Function</title>
  <shortdesc>This function can be used in conjunction with the CSS <codeph>content</codeph> property
    to change the style of generated text.</shortdesc>
  <prolog>
    <metadata>
      <keywords>
        <indexterm>CSS extensions<indexterm>Custom
            functions<indexterm>oxy_label</indexterm></indexterm></indexterm>
      </keywords>
    </metadata>
  </prolog>
  <conbody>
    <p id="p_rzc_dgk_54b">The arguments of the function are <i>property name - property value</i> pairs. The following
      properties are supported:<ul id="ul_szc_dgk_54b">
        <li id="li_tzc_dgk_54b"><ph conkeyref="reusables-author-mode-customization/text-property"/></li>
        <li id="li_uzc_dgk_54b"><ph conkeyref="reusables-author-mode-customization/width-property"/></li>
        <li id="li_vzc_dgk_54b"><ph conkeyref="reusables-author-mode-customization/color-property"/></li>
        <li id="li_wzc_dgk_54b"><ph conkeyref="reusables-author-mode-customization/background-color-property"/></li>
        <li id="li_xzc_dgk_54b">
          <p id="p_yzc_dgk_54b"><uicontrol>styles</uicontrol> - Specifies styles for the form
            control. The values of this property are a set of CSS properties:<ul id="ul_rrh_nyh_sr">
              <li id="li_zzc_dgk_54b"><uicontrol>font-weight</uicontrol>,
                  <uicontrol>font-size</uicontrol>, <uicontrol>font-style</uicontrol>,
                  <uicontrol>font</uicontrol></li>
              <li id="li_a1d_dgk_54b"><uicontrol>text-align</uicontrol>,
                  <uicontrol>text-decoration</uicontrol></li>
              <li id="li_b1d_dgk_54b"><uicontrol>width</uicontrol></li>
              <li id="li_c1d_dgk_54b"><uicontrol>color</uicontrol>,
                  <uicontrol>background-color</uicontrol></li>
              <li id="li_d1d_dgk_54b"><uicontrol>link</uicontrol> - For more information about this
                property, see the <xref href="dg-link-elements.dita#dg-link-elements"><i>link</i>
                  property section</xref>.</li>
            </ul></p>
          <p id="p_e1d_dgk_54b">
            <codeblock  id="codeblock_f1d_dgk_54b">element{
    content: oxy_label(text, "Label Text", styles,
      "font-size:2em;color:red;link:attr(href);");
}</codeblock>
          </p>
          <p id="p_g1d_dgk_54b">Instead of using the values of the <codeph>styles</codeph> property individually, you
            can define them in a CSS file as in the following
            example:<codeblock  id="codeblock_h1d_dgk_54b">* {
    width: 40%;
    text-align:center;
}</codeblock></p>
          <p id="p_i1d_dgk_54b">Then refer that file with an <codeph>@import</codeph> directive, as
              follows:<codeblock  id="codeblock_j1d_dgk_54b">elem {
  content: oxy_label(text, 'my_label', styles, "@import 'labels.css';")
}</codeblock><note
              type="caution" id="note_k1d_dgk_54b">Extensive use of the <codeph>styles</codeph> property may lead to
              performance issues.</note></p>
        </li>
      </ul>If the text from an <codeph>oxy_label()</codeph> function contains new lines, for example
        <codeph>oxy_label(text, 'LINE1\A LINE2', width, 100px)</codeph>, the text is split in two.
      Each of the two new lines has the specified width of 100 pixels.<note id="note_l1d_dgk_54b">The text is split after
          <codeph>\A</codeph>, which represents a new line character.</note></p>
    <p id="p_m1d_dgk_54b">You can use the <codeph>oxy_label()</codeph> function together with a <xref
        href="form-controls.dita#form-controls">built-in form control</xref> function to create a
      form control based layouts.</p>
    <p id="p_n1d_dgk_54b"><b><u>Example: <term>oxy_label</term> Function</u></b></p>
    <p id="p_o1d_dgk_54b">An example of a use case is if you have multiple attributes on a single element and you want
      use form controls on separate lines and style them differently. Consider the following CSS
      rule:<codeblock  id="codeblock_p1d_dgk_54b">person:before {
  content: "Name:*" oxy_textfield(edit, '@name', columns, 20) 
    "\A Address:" oxy_textfield(edit, '@address', columns, 20)
}</codeblock></p>
    <p id="p_q1d_dgk_54b">Suppose you only want the <uicontrol>Name</uicontrol> label to be set to
        <uicontrol>bold</uicontrol>, while you want both labels aligned to look like a table (the
      first column with labels and the second with a text field). To achieve this, you can use the
        <codeph>oxy_label()</codeph> to style each label
      differently.<codeblock  id="codeblock_r1d_dgk_54b">person:before {
 content: oxy_label(text, "Name:*", styles, "font-weight:bold;width:200px")
          oxy_textfield(edit, '@name', columns, 20) "\A "
          oxy_label(text, "Address:", styles, "width:200px")
          oxy_textfield(edit, '@address', columns, 20)
}</codeblock></p>
    <note type="tip" id="note_s1d_dgk_54b">A code template is available to make it easy to add the
        <codeph>oxy_label</codeph> function with the <xref
        keyref="glossentry_content-completion-assistant"><term>Content Completion
        Assistant</term></xref> by pressing <uicontrol
        conkeyref="reusable-oxygen-shortcuts-list/ctrl_space"/> and select the <image
        href="../img/CodeTemplates12.gif" id="image_wb2_ghh_5r"/>
      <codeph>oxy_label</codeph> code template.</note>
  </conbody>
</concept>
